﻿using System;
using System.Collections.Generic;
using Windows.UI.Core;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Markup;

namespace DT.GoogleAnalytics.Metro
{
    internal class HostControl : Control
    {
        private const string MainJsCode = @"

//
//var dummyConsole = {
//    assert : function(){},
//    log : function(s,s1){
//window.external.notify('Console Log: '+s+s1);
//},
//    warn : function(s){
//window.external.notify('Console Warn: '+s);
//
//},
//    error : function(s){
//window.external.notify('Console Error: '+s);
//},
//    debug : function(s){
//window.external.notify('Console Debug: '+s);
//},
//    dir : function(){},
//    info : function(s){
//window.external.notify('Console Info: '+s);
//}
//};
//
//window.console = dummyConsole;

  var _gaq = _gaq || [];
  (function() {
    var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
    ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
    if (ga.onreadystatechange !== undefined) {
        ga.onreadystatechange = function () {
            if ((ga.readyState == 'loaded' || ga.readyState == 'complete') && !window.PageTracker) {
                window.external.notify('trying to get tracker');
                window.PageTracker = _gat._createTracker(window.GoogleAnalyticsId);
                window.PageTracker._setDomainName('none');
                window.external.notify('GoogleAnalytics.Initialized');
            }
        }
    }
    document.body.appendChild(ga);  
    window.external.notify('script with ga.js added');
  })();
";
        private const string AccountDetailsJs = "window.GoogleAnalyticsId = '{0}'";

        internal event Action<HostControl> Initialized;

        public HostControl()
        {
            DefaultStyleKey = typeof(HostControl);
        }

        public HostControl(string trackingId)
            : this()
        {
            TrackingId = trackingId;
            //fucking WinRT API http://social.msdn.microsoft.com/Forums/en-US/winappswithcsharp/thread/b827ce9d-09c9-4eaf-8cbf-198b44add90f
            var controlTemplate = XamlReader.LoadWithInitialTemplateValidation("<ControlTemplate xmlns='http://schemas.microsoft.com/winfx/2006/xaml/presentation' xmlns:x='http://schemas.microsoft.com/winfx/2006/xaml' " +
                                                  " " +
                                                  ">" +
                "<Canvas x:Name=\"PART_Root\"/>" +
                                                  "</ControlTemplate>") as ControlTemplate;

            this.Template = controlTemplate;
            //XamlReader.LoadWithInitialTemplateValidation()
        }

        public string TrackingId { get; set; }
        private Canvas PART_Root = null;
        private WebView _webView = null;

        protected override void OnApplyTemplate()
        {
            PART_Root = (Canvas)GetTemplateChild("PART_Root");
            if (PART_Root == null)
            {
                return;
            }
            InitializeWebView();
        }

        private void InitializeWebView()
        {
            if (_webView == null)
            {
                _webView = new WebView()
                {
                    AllowedScriptNotifyUris = new List<Uri>()
                                                                 {
                                                                   new Uri("http://www.google-analytics.com/ga.js"),
                                                                   new Uri("https://ssl.google-analytics.com/ga.js"),
                                                                 },
                };
                if (PART_Root != null)
                {
                    PART_Root.Children.Add(_webView);
                    _webView.LoadCompleted += WebViewLoadCompleted;
                    _webView.ScriptNotify += WebViewScriptNotify;
                    _webView.NavigationFailed += _webView_NavigationFailed;
                    _webView.Navigate(new Uri("ms-appx-web:///blank.html", UriKind.RelativeOrAbsolute));

                }
            }
        }

        private void _webView_NavigationFailed(object sender, WebViewNavigationFailedEventArgs e)
        {

        }

        private void WebViewScriptNotify(object sender, NotifyEventArgs e)
        {
            var stringResult = e.Value;
            if (stringResult == "GoogleAnalytics.Initialized")
            {
                OnGoogleAnalyticsInitialized();
            }
        }

        private void WebViewLoadCompleted(object sender, Windows.UI.Xaml.Navigation.NavigationEventArgs e)
        {
            var js = string.Format(AccountDetailsJs, TrackingId) + MainJsCode;
            try
            {
                _webView.InvokeScript("eval", new string[] { js });
            }
            catch (Exception)
            {
            }
        }

        private void OnGoogleAnalyticsInitialized()
        {
            if (Initialized != null)
            {
                Initialized(this);
            }
        }

        internal void RunAnalyticsJsCode(string fullJsCode)
        {
            Dispatcher.RunAsync(CoreDispatcherPriority.Normal, () =>
            {
                try
                {
                    _webView.InvokeScript("eval", new[] { fullJsCode });
                }
                catch (Exception) { }
            });
        }
    }
}
