﻿namespace DT.GoogleAnalytics.Metro
{
    public class GoogleAnalyticsSettings
    {
        private string _webPropertyId;

        public string WebPropertyId
        {
            get { return _webPropertyId; }
            set
            {
                _webPropertyId = value;
                if (!string.IsNullOrWhiteSpace(value))
                {
                    AnalyticsHelper.SetTrackingId(value);
                }
            }
        }

        private bool _modelTrackingEnabled = true;
        /// <summary>
        /// Should we send model-tracking information to GA. Enabled by default
        /// Custom variables: 
        /// 1 - Custom PC       string  Yes/No
        /// 2 - Manufacturer    string 
        /// 3 - Model           string
        /// </summary>
        public bool ModelTrackingEnabled
        {
            get { return _modelTrackingEnabled; }
            set
            {
                _modelTrackingEnabled = value;
                AnalyticsHelper.SetModelTrackingEnabled(value);
            }
        }

    }
}